//
// osnovnih 6 funkcij MPI
//

#include <stdio.h>
#include <string.h>
#include <mpi.h>

#define BUF_SIZE 80

int main(int argc, char* argv[])
{
	int		myid, size;
	char	buffer[BUF_SIZE];
	int		i;

	MPI_Init(&argc, &argv);

	MPI_Comm_rank(MPI_COMM_WORLD, &myid);
	MPI_Comm_size(MPI_COMM_WORLD, &size);

	if(myid == 0)
	{
		printf("Pozdrav, sem proces %d, gospodar %d procesov!\n", myid, size);
		for (i=1; i < size; i++)
		{
			MPI_Recv(buffer, BUF_SIZE, MPI_CHAR,
				     MPI_ANY_SOURCE, MPI_ANY_TAG, MPI_COMM_WORLD, 
					 MPI_STATUS_IGNORE);
			printf("%s", buffer);
		}
	}
	else
	{
		sprintf(buffer, "Pozdravljen, sem proces %d.\n", myid);
		MPI_Send(buffer, strlen(buffer)+1, MPI_CHAR,
			     0, myid, MPI_COMM_WORLD);
	}

	MPI_Finalize();

	return 0;
}
